/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 


/*  xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
     coded in ECMAScript 5 - JavaScript 5  (ES5, ECMAScript 2009)
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx */


//  xxxxxxxxxxxxxxx   rst variable declarations  xxxxxxxxxxxxxxxx


// These variables below can be directly modified by the user on the options form: 

var itemCnt = 6;   // total item count in task => itemCnt= parseInt(document.getElementById("items").value, 10);    

var parad = "0";     // Paradigm type   ["0" => Color name;  "1" =>Spatial position] 
       
var mtype = "1";   //  mtype= ["0" => Match by text content; "1" => Match by font color;]

var ptype = true;   // 4 choices colors positions. if(true) == fixed positions ("0") or if (false) == randomly changed in task ("1")

var neutral= false;  //  use neutral stimuli in research: "0" => false (No);  "1" => true(Yes)

var no_correct = false;  // if (false) => An exact solution must exist in each item. if (true) => It is possible that sometimes the exact solution will not exist

var upcase = true;   // if (true) use uppercase letters for all text content; else use (lowercase) text content 

var is_back = true; // if (is_back==true) => user can go back to previous item (Undo) 

var is_forward= true;  // if (is_forward==true) => user can escape (skip) items. Next item button vill be visible. 

var demo = true;     // if (demo == true) => show correct solution

var timer = 600;     // Task time in seconds if clock = 1000ms (default). 

var prg_type = "0";   //  type of information in Progress Bar => ("0" == items to end; "1" == remaining Time; "2" == Nothing )

var store = false;   // false => this web application will not store results within client web browser.; true => This web application will store the results inside client web browser. 

// Other constants and internal rst variables:

var clock = 1000;  // basic timer resolution in ms. Default = 1s (1000ms)

var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().

var counter = 0;      // timer counter. if (counter >= time) Timer will call theEnd()   

var item = 0;   // current item      

var dx;    // offset in the x-axis direction (for drawing cells)

var dy;   // offset in the y-axis direction (for drawing cells)

var dirty = false;  // if  (dirty==true) => user changed any options in form 

var is_task = false;    // task in progress or not  (for timer)
 
var fontStyle;        // canvas text font style 

/*  stim = jagged array= [item][shape] =>
[
[0] = x; [1] =y; [2]= text; [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected; [6] = responds to selection (click) or not; 
]*/
var stim = [];  

var stim_b = [];  // canvas (stimulus grid) bounds => stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom

// default HTML Color Names strings. Color Names Supported by all Browsers
var clr = ["red", "blue", "green", "yellow", "purple", "brown", "lime", "cyan", "magenta", "silver", "maroon", "olive", "teal", "navy", "pink", "orange" ];     
    
// user defined color names. 
var clr_c = null;  // each USED custom color is jagged array: [0=default html color name, 1=custom color name]

var is_storage;       // if (true) => Web Storage Object is available

var custom_clr= false;  // if (true) => user defined color names will be used. Else: default html color names will be used in research

var pattern=[];       //  array of color index for last 4 choices set. bounds: [0..3] 

var itype= [];     // item type: if (neutral) => [0 = consistent stimulus; 1=inconsistent stimulus; 2 =neutral stimulus].  if (!neutral) => [0 = consistent stimulus; 1 = inconsistent stimulus]

var itime=[];      // display time for each item in task (ms)

var startTime;     // start of display time for current item

var other = [ 'up',  'left', 'right', 'down', '????' ];   // default spatial positions (index 0..3 + neutral stimulus text content at index 4)

var lang_click= false;    // using for update loadStorage()  



//  xxxxxxxxxxxxxxx     rst functions  xxxxxxxxxxxxxxxx



// init html page [create/start Timer, check storage, show start panel..] 
function init() 
{  
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {rstTimer()},clock);      
  if (isStorage() && storageAvailable('localStorage'))  {
    is_storage=true;		 
    document.getElementById("store_group").setAttribute("style", "display:block");  
    document.getElementById("no_storage").setAttribute("style", "display:none");  
		loadStorage();   		
  }
  else  {
    is_storage= false;
    document.getElementById("store_group").setAttribute("style", "display:none");  
    document.getElementById("no_storage").setAttribute("style", "display:block");      
  } 
  
	showStart();  
}


// Load user-defined language settings (color names, spatial positions, neutral stimulus text) 
function loadStorage() 
{ 
  var tmp= localStorage.getItem('rst-v1.0-other'), len;   // Retrieve the spatial positions (up, down, left, right) and neutral stimulus content from storage
	if (tmp)  
	{
		tmp= JSON.parse(tmp);
		len=tmp.length;   // spatial positions (up, down, left, right index: 0..3) and neutral stimulus content (index=4)
		if (len === 5) 
		{  
	    other=[];
			for (var i=0; i<5; i++) {				
				other[i]= tmp[i];  //other.push(tmp[i]);
      }	       			
		}
	}	

	clr_c= null;  // reset to default 
  custom_clr= false;    // reset to default
	tmp= localStorage.getItem('rst-v1.0-colors'); // Retrieve the custom colors names from storage. For each 16 colors jagged array: [index 0= custom color name; index 1 = use or not in research]
	if (tmp)  
	{
		tmp= JSON.parse(tmp);
		len= tmp.length;   
		if (len === 16) 
		{ 
			var sel_4 = document.getElementById("clr_4"), sel_5 = document.getElementById("clr_5"), opt; 
			sel_4.innerHTML="";
			sel_5.innerHTML="";
			for (var i= 0; i< len; i++) 
			{  
		    opt = document.createElement("option");
				opt.value = i;  // option value index [1] => html color name             
				opt.text = tmp[i][0]; // user defined color name (index 0)
					//opt.setAttribute("data-color", clr[j]);   // default html color name
				if (tmp[i][1]==true)  { // use this color in research (index 1)                          									
					sel_4.add(opt);  // sel_4.add(opt, null);              
				}
				else	{ // this is color list which are "not used" => you can use selected 5. color in case where there is no correct solution in task 				  				    
					sel_5.add(opt);  // sel_5.add(opt, null); 	
				}			
			} 
			sel_4.selectedIndex=0; 
      sel_5.selectedIndex=0;			
			document.getElementById("clr_4_msg").textContent= "User defined color names will be used";                    		
			// now try to set set window.custom_clr array..
			// for each color name index 0 == color name,  index 1 == true/false use or not     
			clr_c= [];  // init global array of custom colors names retrieved from storage 
			var j= 0;   // this is index (counter) from window.clr array
			var k= 0;   // this is index (counter) from window.clr_c array
			for (var i in tmp) 
			{  
				if (tmp[i][1]==true)  
				{   // use this color in research (index 1)
					clr_c[k]= [];  // for each USED custom color push jagged array: [0=default html color name, 1=custom color name]
					clr_c[k]= [clr[j], tmp[i][0]];   // [index 0 = clr[j] => default html color name, index = 1 => original custom color name from storage]            
					k++;
				}
				j++;
			} 
			if (clr_c.length === 4)  {
				custom_clr=true;  
			}      		
		}  // if (len === 16)
	}
  
	setIns();	  
}


// show start panel 
function showStart()  
{      
  document.getElementById("end").style.display= "none";
  document.getElementById("google_wrapper").style.display="none";
  document.getElementById("table_grp").style.display="none";  
  document.getElementById("start").style.display= "block";
}


// before using web storage, check browser support for localStorage and sessionStorage
function isStorage()  {
  if (typeof(Storage) !== "undefined") {
     return true;               //  localStorage/sessionStorage is supported     
  } 
  else {
    return false;           // no browser Web Storage support
  }  
}


// necessarily because of IE11 and Edge offline mode
function storageAvailable(type) {
  try  {
    return (window[type]) ? true: false;   
  }
  catch(e) {
    return false;
  }
}


// show forms with application options (settings)
// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   
{
  document.getElementById("hide_option").style.display ="block";
  document.getElementById("options").style.display= "block";
  document.getElementById("start").classList.remove("child");  // don't work in <= IE 9    
  document.getElementById("start_div").style.display="none";  // .disabled = true;   
  document.getElementById("show_option").style.display ="none";  
  document.getElementById("hide_option").setAttribute("style","text-align:center");  
  document.getElementById("instructions").style.display="none";     
  if (document.getElementById("store_group").disabled === false && localStorage.getItem("rst-v1.0-data")) 
  {
    var cnt= JSON.parse(localStorage.getItem("rst-v1.0-data")).length;                                                        
    document.getElementById("store_cnt").textContent=  "You have a total of " + cnt  + " rst results stored in your web browser";
  }
	 
  document.getElementById("is_valid").textContent= "";  
  document.getElementById("is_valid").setAttribute("style","text-align:center;color:#000000"); 
	
  dirty= false;
	lang_click= false;
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user Options/Settings
function hideOption()  
{ 
  refMsg();  
  
	setVarPar(); 
   
  document.getElementById("options").style.display="none"; 
  document.getElementById("start").classList.add("child");   
  document.getElementById("show_option").style.display ="block";   
  document.getElementById("start_div").style.display="block";        //.removeAttribute("disabled");  
  document.getElementById("hide_option").style.display ="none";   
  document.getElementById("start_div").setAttribute("style","text-align:center"); 
  document.getElementById("show_option").setAttribute("style","text-align:center"); 
  document.getElementById("instructions").style.display ="block";
  document.getElementById("ins_back").style.display = (is_back) ? "block" : "none";
   
	setIns();
}

function setIns()
{
	var sins= (is_storage) ? localStorage.getItem('rst-v1.0-ins') : null; // Retrieve the instruction text content from storage   
	if (sins)  
	{  // if (true) => user defined instruction text content will be used.       
		document.getElementById("custom_ins").setAttribute("style", "display:block");
		document.getElementById("custom_ins").textContent= sins;
		document.getElementById("def_ins").setAttribute("style", "display:none");      
  }   
	else {
    setDefIns();  // Else: default instructions text will be used in research
  }   
	
}	

// display setting (update) default instructions text content..
function setDefIns()  
{      
  document.getElementById("def_ins").setAttribute("style", "display:block"); 
    
  for (var i= 0; i< 2; i++)  {  //  mtype= ["0" =>Match by text content; "1" => Match by font color;]
    document.getElementById("ins_" + i).style.display= (mtype == i) ? "block" : "none";
  }
 
	document.getElementById("ins_nocor").style.display= no_correct ? "block" : "none";
	
	document.getElementById("ins_back").style.display= is_back ? "block" : "none";
	
  document.getElementById("ins_timer").textContent= "Remember that the duration of this task is always limited.";
  if (prg_type === "0")  {
    document.getElementById("ins_timer").textContent+=" At the bottom of the screen will be information on how many items are left until the end of the task.";
  }
  else if (prg_type == "1")  {
     document.getElementById("ins_timer").textContent+= " The remaining time until the end of the task is shown to you at the bottom of the screen.";  
  }
  else  {
     document.getElementById("ins_timer").textContent+= " But information about the remaining time will not be visible";  
  }  
  document.getElementById("ins_demo").style.display= demo ? "block" : "none";
}

       
// refresh variable research Options (update *_msg label) => give user short option HELP
function refOption(e)  
{   
  dirty=true;       
  var my_id = e.id, msg = document.getElementById(my_id + "_msg"), s = "Values within this range are allowed: ", s2= " with step= ";    
  
  switch (my_id)
  {
        
    case "items":      
      if (e.validity.valid)  {           
        msg.removeAttribute("class");       
        msg.textContent= (document.getElementById("neutral").value === "0") ? "If you do not use a neutral stimulus the number of items in the task must be divisible by 2 without remainder" : "If you use a neutral stimulus the number of items in the task must be divisible by 3 without remainder";               
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");    // msg.className = 'error'; 
      }       
      break; 
                              
    case "parad":            
        msg.textContent= (e.value === "0") ? 'The text content of the word in the middle of the screen shows the color names. Default: red, blue, green, yellow.' : 'The text content of the word in the middle of the screen shows the positions. Default: up, left, right, down.';                    
      break;
                                                     
    case "mtype":         
      if (e.value === "0")  {    //  match by word meaning (text content)
				msg.textContent='The association between stimuli and responses is based on the textual content of the word. The participant should ignore the font color of the displayed word and focus only on the textual content of the printed word. The correct choice (color rectangle) is the one that has the printed background color or is in the space position indicated by the printed word.';								
        document.getElementById("fs_nocorrect").disabled= false;    // enable no solution for match by text cpontent
				document.getElementById("neutral").value= "0";  // no neutral stimulus
				document.getElementById("neutral").selectedIndex= 0;   // no neutral stimulus
				document.getElementById("neutral").disabled= true;
				document.getElementById("neutral_msg").textContent= 'Disabled for Match type = Match by text content';			
			}
      else /*if (e.value === "1")*/  {  // match by font color
        msg.textContent= 'The association between stimuli and responses is based on the font color of the word displayed. The participant should ignore the content of the displayed word and focus only on the font color of the printed word. The correct choice (color rectangle) is the one that has a background color equal to the font color of the printed word in the middle of the screen.';
				document.getElementById("fs_nocorrect").disabled= true; 		// disable no correct choice for match by font color	
				document.getElementById("neutral").disabled= false;  // enable neutral stimulus
				document.getElementById("neutral_msg").textContent= (document.getElementById("neutral").value === "0") ? "Neutral stimuli will not be used in the research" : "Neutral stimuli will be used in the research. You can set text content for neutral stimulus in Language section";       
			}      
      break;
    
    case "ptype":
			msg.textContent= (e.value === "0") ? "The colors of the choices (rectangles) will always be in the same positions during the task. Default: red=top, blue=left, green=right, yellow=bottom" : "The colors of the choices (rectangles) will change positions during the execution of the task (random moved)";		
			break;
			
    case "neutral":  // neutral= document.getElementById("neutral").value === "1" ? true : false;      
       if (e.value === "0") {
				msg.textContent= "Neutral stimuli will not be used in the research";
			  document.getElementById("items_msg").textContent="If you do not use a neutral stimulus the number of items in the task must be divisible by 2 without remainder";
			 }
			else  {
				msg.textContent= "Neutral stimuli will be used in the research. You can set text content for neutral stimulus in Language section";         
				document.getElementById("items_msg").textContent=	"If you use a neutral stimulus the number of items in the task must be divisible by 3 without remainder";
			}
      break;
    
		case "no_correct":      
      if (e.checked) {
				msg.textContent= "It is possible that sometimes the exact solution will not exist. Then the participant should click on the printed word or the white rectangle in the middle of the screen.";
				document.getElementById("clr5").setAttribute("style", "display:block");
					
			}
			else  {
				msg.textContent= "An exact solution must exist in each item.";
				document.getElementById("clr5").setAttribute("style", "display:none");	
			}
			break;
		
		
    case "upcase": 
      msg.textContent= e.checked ? "Uppercase letters for all text content will be used in research" : "Lowercase letters for all text content will be used in research"; 
      break;
    
    case "is_back":   
      msg.textContent= e.checked ?  "It is possible to return to the previous item and correct the selection." : "It is not possible to return to the previous item and correct the selection.";         
      break;
     
    case "is_forward":   
      msg.textContent= e.checked ?  " Yes" : " No";         
      break;		 
		
    case "demo":    
      if (e.checked)  {
        msg.textContent= " Yes - All correct choices will have black border like this";
        msg.setAttribute("style", "background-color:white;border:5px solid black");   // background-color:ivory; border:red; border:1px solid #FF0000;
      }
      else  {
        msg.textContent=" No";
        msg.removeAttribute("style");
      }    
      break;
           
    case "timer":
      if (e.validity.valid)  {
        msg.textContent= stringTime(e.value); 
        msg.removeAttribute("class");
      }
      else  {
        msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
        msg.setAttribute("class", "error");
      } 
      break;                
             
    case "prg_type":                                                                                                                                            
      if (e.value === "0")  {
        msg.textContent= "It will be displayed how many items are left to the end.";
      }
      else if (e.value === "1")  {
        msg.textContent= "The remaining time until the end of the task will be displayed.";
      }
      else  {
        msg.textContent= "The timer will be on, but information on how much time is left until the end of the task will not be visible.";
      }
      break;   
      
    case "store":                                                                                                                                            
      msg.textContent= (e.value === "1") ? "This web application will store the results inside your web browser (no expiration date). Useful for group research" : "This web application will not store results within your web browser. Data is lost when the browser tab is closed";
      break; 
            
  }   // switch (my_id)
       
}


// refresh main validator message for user defined OPTIONS (feedback to user)
function refMsg()   
{ 
  if ( optionsValid() )  {
    document.getElementById("is_valid").textContent=  (dirty===true) ? "All your settings have been successfully updated" : "";  
    document.getElementById("is_valid").setAttribute("style", "text-align:center;color:#000000"); 
  }
  else  {
    document.getElementById("is_valid").textContent="Some of your options are incorrectly set. They were not updated. These settings are marked in red."; 
    document.getElementById("is_valid").setAttribute("style", "text-align:center;color:#ff0000;font-weight:bold"); 
  } 
}
 

// check for validity.valid object in all input type="number" 
function optionsValid()  
{     
	var res= document.getElementById("items").validity.valid  && document.getElementById("timer").validity.valid
	  && ( (document.getElementById("neutral").value === "1" && document.getElementById("mtype").value === "0") === false );              
  return res;  // not allowed to use neutral stimuli for mtype= "0" => Match by text content          
}


// start rst Task (start Research) 
function startTask(e)   
{       
  e.disabled= true;
  stimGenerator(); 
  e.disabled= false;   
  do  
    var ok= e.disabled;
  while (ok); // timer will wait for stimulus generator for large itemCnt 
  document.getElementById("google_wrapper").style.display="none";
  document.getElementById("end").style.display= "none"; 
  document.getElementById("start").style.display= "none"; 
  document.getElementById("canvas").style.display="block";                  
  document.getElementById("progress").style.display= "block";     
  document.getElementById("progress").setAttribute("style", "width:100%");   
  document.getElementById("time_left").textContent= "";
  
  if (document.getElementById("prg_type").value === "0") {
     document.getElementById("progress").className="progress-bar progress-bar-info progress-bar-striped";     // items/total
  }
  else if  (document.getElementById("prg_type").value === "1")  {
     document.getElementById("progress").className= "progress-bar progress-bar-danger progress-bar-striped";  // remaining time   
  }  
  document.getElementById("progress").setAttribute("style", "width:0");  // reset progress bar width
  
  counter= 0;       // reset timer counter
  is_task= true;    // finally activate timer
  
  drawStim(true);     // draw first stimulus   
}


// set application variable parameters
function setVarPar()  
{          
  if (document.getElementById("items").validity.valid) 
	{ // autocorrect itemCnt only for valid element "items" 
	  var tmp= parseInt(document.getElementById("items").value, 10)-1, ok;
		do
		{ 
		  tmp++;
			if (document.getElementById("neutral").value === "1")  {
				ok= tmp % 3 === 0 ? true: false;
			}	
			else   {
				ok= tmp % 2 === 0 ? true: false;			
			}						
		}
		while (!ok);
		if (tmp != document.getElementById("items").value )  {
			document.getElementById("is_valid").textContent= document.getElementById("neutral").value === "1" ? "If you use a neutral stimulus the number of items in the task must be divisible by 3 without remainder. Autocorrected value=" + tmp : "The number of items in the task must be even, ie divisible by 2 without remainder. Autocorrected value=" + tmp; 
			document.getElementById("is_valid").setAttribute("style", "text-align:center;color:#ff0000;font-weight:bold"); 
		}		
		document.getElementById("items").value= tmp;
		itemCnt= tmp; 				       
  } 
	
  parad= document.getElementById("parad").value;    // Paradigm type   ["0" => Color;  "1" =>Spatial] 
  
  mtype= document.getElementById("mtype").value;     //  mtype= ["0" => Match by word (text content); "1" => Match by font]
  
	ptype= (document.getElementById("ptype").value === "0") ? true : false;  // choices colors positions "0" => true == fixed positions  or "1" => false == randomly changed in task
  
  if (mtype != "1") {  
		document.getElementById("neutral").value= "0"; // hidden autocorrect => no neutral stimulus for Match by text content
	}
	neutral= (document.getElementById("neutral").value === "1" && mtype === "1") ? true : false;       //  use neutral stimuli: "0" => false (No);  "1" => true (Yes)
 
  no_correct= (document.getElementById("no_correct").checked && mtype === "0")? true: false;    // if (true) => It is possible that sometimes the exact solution will not exist; if (false) => An exact solution must exist in each item. 
	
	upcase= document.getElementById("upcase").checked ? true: false;    // uppercase or lowercase color names
  
  is_back= document.getElementById("is_back").checked ? true: false;   // enable Go back (previous item)      
  
  is_forward= (document.getElementById("is_forward").checked) ? true: false; // enable skip item
  
  demo= document.getElementById("demo").checked ? true: false; // demo mode = true => show correct solution
      
  if (document.getElementById("timer").validity.valid) {
		timer= Math.round(parseInt(document.getElementById("timer").value, 10));  
  }
  prg_type= document.getElementById("prg_type").value;   //  type of information displayed on Progress Bar   
    
  store= (is_storage === true && document.getElementById("store").value === "1") ? true : false;
  
	 if (is_storage && lang_click) {
		 loadStorage();        
	}		
}


// main stimulus generator function
function stimGenerator()  
{ 
  var ind, prior=null;    
  
  setPar();      
  
  setPage();
  
  for (var i=0; i<itemCnt; i++)     // i == next item => ordinal item count [0..itemCnt-1]    
  {     
    do {
      ind= getRndInt(0,3);
    } while (ind === prior);            
    stim[i]= [];   
    stim[i]= setStim(i, ind, prior); 
    prior= ind;   
  }
  
}


// set internal application parameters
function setPar()  
{            
  stim_b= [];  // bounds for stimulus
  stim= [];    
  item= 0; 
  pattern = [0,1,2,3];  // Default positions: red=top, blue= left, green= right, bottom= yellow         
  itime=[];   
  if (mtype != "1")  {
		neutral=false;       //  mtype= ["0" => Match by text content; "1" => Match by font color;]
  }
	var f_max;
  if (neutral) 
  {
     f_max= Math.round(itemCnt/3);
     for (var j=0; j<itemCnt; j++)       
		 {   // j== item => ordinal item count [0..itemCnt-1]      
       itime[j]=0;
       if  (j < f_max) {
         itype[j]= 0;  //  consistent stimulus
       }
       else if  (j < 2*f_max) {
         itype[j]= 1;  // inconsistent stimulus
       } 
      else  {
         itype[j]= 2;  // neutral stimulus
       }         
    }
  }
  else
  {
    f_max= Math.floor(itemCnt/2); 
    for (var j=0; j<itemCnt; j++)       {   // j== item => ordinal item count [0..itemCnt-1]      
      itype[j]=(j < f_max) ? 0 : 1;       // 0 == consistent stimulus; 1 == inconsistent stimulus
			itime[j]=0;
		}
  }
  itype=shuffle(itype);  
  // update uppercase (lowercase)    
	if (custom_clr)  {  
    for (var i in clr_c)  {  // each USED custom color is jagged array: [0=default html color name, 1=custom color name]        
       clr_c[i][1]= upcase ? clr_c[i][1].toString().toUpperCase() : clr_c[i][1].toString().toLowerCase();   // [index 0 => default html color name, index 1 => custom color name from storage]            
    }
  }
  else {
    for (var i in clr)  {
      clr[i]= upcase ? clr[i].toString().toUpperCase() : clr[i].toString().toLowerCase();
    }     
  } 
  // uppercase (lowercase) 4 spatial positions + neutral stim
	for (var i in other)  {
		other[i]= upcase ? other[i].toString().toUpperCase() : other[i].toString().toLowerCase();
  }  
}


// unbiased shuffle algorithm: Fisher-Yates (aka Knuth) Shuffle.
function shuffle(arr) 
{
  var cur_index= arr.length, tmp, rnd_index;    
	while (0 !== cur_index)  {    // while there remain elements to shuffle...
    rnd_index = Math.floor(Math.random() * cur_index);     // pick a remaining element...
    cur_index = cur_index - 1;   
    tmp = arr[cur_index];          // and swap it with the current element.
    arr[cur_index] = arr[rnd_index];
    arr[rnd_index] = tmp;
  }
  return arr;
}


/* set canvas (viewport) choices (options) bounds        
   stim_b array =>  [0] = left; [1] = top; [2] = right; [3]= bottom  */
function setPage()  
{     
  document.getElementById("footer").style.display="block";  
  document.getElementById("footer").height= "50";  
  var canvas= document.getElementById("canvas");     
  canvas.left= 0; 
  canvas.top= 0;
  canvas.width= window.innerWidth;       // stretch canvas to parent
  canvas.height= window.innerHeight - document.getElementById("footer").height;                                                  
  // set viewport cells raster (dx, dy) 
  dx = Math.floor(canvas.width/3);  
  dy = Math.floor(canvas.height/3);     

  //  stim_b =>  [0] = left; [1] = top; [2] = right; [3]= bottom      
  stim_b= [0, 0, canvas.width, canvas.height];                                                                                                                  
   
	setFont();   
  
	//if (Math.floor(Math.min(dx,dy)) < 10) alert("Your screen resolution is probably not enough to distinguish the text that will be displayed.");        
}
   

// todo: this function is not the smartest. All suggestions and improvements are more than welcome.. 
function setFont()
{ 
  // adjust the optimal font horizontally
  var canvas= document.getElementById("canvas");    
  var ctx = canvas.getContext('2d'); 
  var w_max= 0, w_tmp, s;  
  var tmp= custom_clr ? clr_c : clr; 
  for (var i in tmp)  {
    w_tmp= ctx.measureText(tmp[i]).width;    
    if (w_tmp > w_max) {
      w_max= w_tmp;
      s= tmp[i];  // x-longest color name (default names or custom colors names)
    }  
  } 
	// do same for 4 spatial positions and neutral stimulus text
  for (var i in other)  {
		w_tmp= ctx.measureText(other[i]).width;    
    if (w_tmp > w_max) {
      w_max= w_tmp;
      s= other[i];  
    }  
	}		
  var size=window.innerWidth/3;  
  do  
  {
    size--;
    ctx.font= size + "px Georgia";
  } while (ctx.measureText(s).width >= dx) ;
  
  size= Math.min(size,dy);   // adjust the optimal font vertically  
  //size= Math.round(0.9*Math.min(size,dy));
  fontStyle= size + "px Georgia";   
}


/* set match and sample coordinates; generate stim-coord (x,y) and default properties (target/non-target, color, shapes type)
 divide screen into raster equal segments (x-horizontal and y-vertical) 
 return array  stim coordinates =>  array index: [0] = x; [1] =y; [2]= text; [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected; [6] = responds to selection (click) or not;
 parameters:   itm = ordinal item count. range= [0..itemCnt-1]
               ind = index of color for target stimulus     
               prior = index of target color for previous stimulus  */ 
function setStim(itm, ind, prior)  
{   
  var _left=stim_b[0], _top= stim_b[1], x, y=_top, off = { 1: 0, 3: 1, 5: 2, 7: 3 };          // stim_b array =>  [0] = _left; [1] = _top;
	var pos, col, txt, is_target, is_answer, tmp, arr= [];   // arr[] => function result
  var e = document.getElementById("clr_5");  // list of possible 5. colors (no correct choice)
	var clr5_ind= e.value;  // 5. color index (pointer for html color name) if there is no correct solution in this (itm) item
	var clr5_txt = e.options[e.selectedIndex].text;  // user defined color name (5. color if no correct choice in item)
	var is_sol= (no_correct && Math.random() < 0.2) ? false : true;  // this item has solution or not. no_correct => if (true) => It is possible that sometimes the exact solution will not exist	
	if  (!ptype)  {
    set4Choices(prior,ind);  
  }
  // set cells content (font color or backgroundColor or text)
  pos= 0;  
  for (var i=1; i<=3; i++) 
  { // i == screen row == x     
    x=_left;
    for (var j=1; j<=3; j++)  
    { // j == screen column == y                                                                       
      is_target= false;
      is_answer= false;      
      
      if (typeof off[pos] != "undefined")  //  if (pos == 1 || pos == 3 || pos == 5 || pos == 7)  { 
      {     // this screen section always responds to selection (click) => 4 rectangles filled with backgroundColor
        is_answer= true;
        tmp= off[pos];  // 0..3
        is_target= (is_sol && pattern[tmp] == ind) ? true : false; 
        col= getColor(pattern[tmp],true);   // this is choice  background color (choices = 4 rectangles in default color: red, greeen, blue, yellow)
				txt= "";  // text is not used here     							
      }             
      			
      else if (pos == 4)   
      {  // this is screen section for target word or text content (printed in screen center)                                
				
				if (no_correct)	{   // no_correct => if (true) => It is possible that sometimes the exact solution will not exist
					is_answer= true;  // for ALL ITEMS (0..itemCnt-1) this screen section pos=4 now responds to selection if it is possible that sometimes the exact solution will not exist
				}	
				if (itype[itm] == 0 || itype[itm] == 2 || is_sol == false)                
        { //  consistent stimulus (0) or neutral stimulus(2). neutral stimulus is only available for mtype = "1" => Match by font color; see setPar() 
                     				  					
					if (is_sol) {
						col= getColor(ind, true);      // font color for printed word in screen center (pos=4)
						txt= (parad == "0") ? getColor(ind, false) : txtPattern(ind, true);     // printed text content in screen center. parad => ["0" => Color;  "1" =>Spatial]           
					}					
					else  /*if (!is_sol)*/ {				
            col= clr[clr5_ind];  // no correct choice => font color for 5. color. this is always html name: document.getElementById("clr_5").value 				
						txt= clr5_txt;      // default or user defined color name for 5. color (if there is no solution). can be different from html color name
						is_target= true;   // this is "correct" choice if there is no correct choice (solution) in this item
					}	          
					if (itype[itm] == 2)  {
						txt= other[4];  // neutral stimulus text content. neutral stimulus is only available for mtype = "1" => Match by font color; see setPar()  
					}					
        }
        
				else /*if (itype[itm] === 1 && is_sol)*/   
        {  // inconsistent stimulus (different font color and text content of the word) => pos==4
          do  {
            tmp= getRndInt(0,3);
          } while (tmp == ind);          
					if (mtype == "0")  
          {  //  mtype= "0" => Match by text content;            
            txt= (parad == "0") ? getColor(ind, false) : txtPattern(ind, true);  // text content (word) in screen center             
            col= getColor(tmp, true);   // change font color for word in screen center => it is inconsistent with text content now              
          }
          else  
          { //  mtype= "1" => Match by font color;
            col= getColor(ind, true);   // word in screen center => font color            
            txt= (parad == "0") ? getColor(tmp, false) : txtPattern(ind, false);  // change text content for word in screen center => it is inconsistent with font color now                           
          }            
        }
        			        
      }   // else if (pos == 4)  
          
      else  
      { // this is non-responsive screen region  => not used in drawStim() => pos= [0, 2, 6, 8]           
        col="white"; 
        txt="";      // text is not used here   
      }
			
      arr.push([x, y, txt, col, is_target, false, is_answer]);   // [0] = x; [1] =y; [2]= text; [3] = color; [4] = target or not-target stimulus; [5] = selected or not selected; [6] = responds to selection (click) or not;      
      x+=dx; // add x => goto new rectangle (screen section) within row 
      pos++;    
    } 
    y+=dy;   // new row (add y)
  }     
  return arr;    
}


/* sets one of mostly basic html predefined colors. this is mostly default set of 16 html Basic colors 
 par: ind == array index (for global window.clr or window.clr_c arrays)
 par: is_clr => is used ONLY for custom color names. 
 if (is_clr==true)  return html (default) color name (for font color); 
 if (is_clr==false) return custom color names (for text content) */
function getColor(ind, is_clr) 
{
  if (custom_clr) 
  {
    if (is_clr)   {
      return clr_c[ind][0];  // html color name (for font). index 0
    }
    else  {
      return clr_c[ind][1];  // custom color name string (for text content). index 1
    }  
  }
  else  {  
    return clr[ind];  // default: font color names == text content
  }
}


/* this function set text for text in screen center if parad == "1" (spatial)
 par: ind = index of correct color (from window.pattern array)
 par: if (is_cor==true)  => return the correct position of the target choice
 par: if (is_cor==false) => return the incorrect position of the target choice  */
function txtPattern(ind, is_cor)
{         
  var cor, rnd; 
  for (var i=0; i<4; i++)  
  {
    if (pattern[i] == ind)  
    {           
      if (is_cor) {  
        return other[i];      
      }
      cor=i;
      break;        
    } 
  }  
  do {
    rnd=getRndInt(0,3);
  } while (rnd == cor); 
  return other[rnd];
}


/* set colors pattern for 4 colors screen rectangles (4 choices)
   prior = target index for last item (or null if this is first item);
	 ind = current target index;  */
function set4Choices(prior, ind)  
{
  var  p, sel= {}, res=[], f=-1, s;  
  if (prior == null) 
  {
    for (var j=0; j<=3; j++)
    {  
      do  {  
        p= getRndInt(0,3);
      } while (typeof sel[p] !== "undefined");
      sel[p]= 1;
      pattern[j]= p;
    }
  }
  else
  {    
    // swap 1. and 2. choices (ind position is always on different position from prior)
    do  {  
      p= getRndInt(0,3);
    } while (p == prior);  // target position in current item must be on different position in relation to the previous item
    // find 3. and 4. array element to swap positions
		for (var i= 0; i<=3; i++)  {
      if (i == ind || i == p) continue;  // escape first two (ind and p)
      if (f === -1)  {
        f= i;  // 3. element
        continue;
      }       
      s=i;  // last one array element => 4. element
    }     
    swap(pattern,ind,p);  // swap 1. and 2. array element (ind <=> p)
    swap(pattern,f,s);    // swap 3. and 4. array element (3.elem <=> 4.elem)    
  }  
}  


// classic swap function
function swap(arr, ind1, ind2) {
  var tmp = arr[ind1];
  arr[ind1]= arr[ind2];
  arr[ind2] = tmp;
}

 
// get random integer from min to max range
function getRndInt(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
}


// application timer handler function
function rstTimer()  
{      
  if (!is_task) {
    return;  // nop, idle        
  }
  counter++;
  if (counter >= timer)  {     // task time is limited
    addTime();
		theEnd();
  }     
  else if (prg_type == "1")  {   // "1" => Time. display time on Progress Bar  
    var rest=timer-counter;   // this is remaining time 
    var percent= Math.round(100*rest/timer);    
    document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
    document.getElementById("time_left").textContent= stringTime(rest);    
  }   
} 


// return integer into string hh:mm:ss time format
// input par: total == integer (time in seconds)
function stringTime(total) 
{
  var hh = Math.floor(total/(60*60));         
  var divisor_for_minutes = total % (60 * 60);
  var mm = Math.floor(divisor_for_minutes / 60);       
  var divisor_for_seconds = divisor_for_minutes % 60;
  var ss = Math.ceil(divisor_for_seconds);    
  // These lines ensure you always have two-digits. This formats your string to HH:MM:SS
  if (hh < 10)  {hh = "0"+hh;}     
  if (mm < 10) {mm = "0"+mm;}
  if (ss < 10) {ss = "0"+ss;} 
  return hh + ":" + mm + ":" + ss;
} 


// goto previous item (stimulus)
function priorAnswer()  
{                         
  if (item > 0)  {     
    addTime();
    item--;  
    drawStim(true);     // draw again previous stimulus
  }         
}


// goto next item (stimulus)
function nextItem()  
{ 
  addTime();              
  if (item < itemCnt-1)  {             
    item++; 
    drawStim(true);     // draw next stimulus        
  }
  else  {               
    theEnd();  // end of task  
  }
}


// see:  https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/getTime
function addTime()  {
  var endTime = new Date(); 
  itime[item]+= endTime.getTime() - startTime.getTime();  // ms  (item == current item in task)	
}	


// draw (repaint) stimulus
// if (ntime == true) => Turn on the stopwatch (start measuring new time for item)    
function drawStim(ntime) 
{    
  var canvas= document.getElementById('canvas');
  var ctx = document.getElementById('canvas').getContext('2d'); 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas             
         
  for (var s in stim[item])   
  {   // s= stimulus number                                           
    ctx.beginPath();     // this section draw square border for each cell => rectangle 
    ctx.rect(stim[item][s][0], stim[item][s][1], dx, dy);   //  	context.rect(x,y,width,height);
    //ctx.lineWidth= 1;        
    if (s == 1 || s == 3 || s == 4 || s == 5 || s == 7) 
    {
			if (s == 4)  {		
			  //ctx.strokeStyle= "#000000"; => const 				    
				drawText(ctx, stim[item][s][0], stim[item][s][1], stim[item][s][2], stim[item][s][3]);  // draw text (word) in grid cell 
			}
      else  {
				ctx.fillStyle= stim[item][s][3];  
				ctx.fill(); 
			}			
      if (demo && stim[item][s][4])    // index [4]= target or not;  
      { 
        //ctx.strokeStyle= "#000000"; // correct choice in demo mode => set border color                        
        ctx.lineWidth= 5;
        ctx.strokeRect(stim[item][s][0]+5, stim[item][s][1]+5, dx-10, dy-10);
      }
      if (stim[item][s][5])  {   // index  [5] == selected or not 
        //ctx.strokeStyle= "#000000"; 
        ctx.lineWidth = 5;
        ctx.moveTo(stim[item][s][0], stim[item][s][1]);
        ctx.lineTo(stim[item][s][0]+dx,stim[item][s][1] +dy);
        ctx.moveTo(stim[item][s][0]+dx, stim[item][s][1]);
        ctx.lineTo(stim[item][s][0],stim[item][s][1]+dy);
        ctx.stroke();
      }      
    }
  }  				
  
  // set footer navigation prior button (left arrow) 
  if (item > 0 && is_back)  {  
    document.getElementById("prior").style.display= "inline"; 
  }
  else  {
    document.getElementById("prior").style.display= "none";   
  } 
  // update "Next item" image on "right arrow" button 
  if (is_forward)       
  {  
    var btn=document.getElementById("next");     
    btn.style.backgroundImage = (item === itemCnt-1)  ?  "url('img/end.png')" : "url('img/forward.png')"; 
    btn.style.display= "inline";  
  }
  else {
    document.getElementById("next").style.display= "none";
  }		
	// display (update) item count on bottom Progress Bar   
  if (prg_type == "0" )  {   
    var percent = 100*(itemCnt-(item+1))/itemCnt;  // Math.round();      
    document.getElementById("progress").setAttribute("style", "width:"+percent+"%");    // !important
    document.getElementById("time_left").textContent= "Item= " + (item + 1) + " Remaining= " + (itemCnt - item-1);  
  }  
	if (ntime) {
		startTime= new Date();
	}	
}


/* draw text on canvas
    ctx = canvas (object) context,
    x = x-left,
    y = y-top,
    txt = text 
    col = color (fillStyle)  
*/  
function drawText(ctx, x, y, txt, col)
{ 
  x+=dx/2;    
  y+=dy/2;     
  ctx.textAlign = "center";
  ctx.textBaseline = "middle";
  ctx.font = fontStyle;  
  ctx.fillStyle = col;  // line color 
  ctx.fillText(txt, x, y);                               
}  


// user selected shape on canvas 
//<canvas id="canvas" onclick="doAnswer(event)"></canvas>   
function doAnswer(e)  
{        
  var x= e.clientX, y= e.clientY;      
	var row = Math.ceil((y - stim_b[1])/dy) -1;    
	var col = Math.ceil((x - stim_b[0])/dx)- 1;   
	if (row <= 3 && col < 3)  
	{
		var p = row * 3 + col; // shape position within stim[item] array               
		if (stim[item][p] && stim[item][p][6] == true)
		{  			
			stim[item][p][5]= (stim[item][p][5] == false) ? true : false;   // toggle (reset) answer if user choose already selected answer        
			for (var j in stim[item])  
			{   // deselect all other choices if they are selected in this item
				if (j != p /*&& stim[item][j][6]==true*/ ) {
					stim[item][j][5]= false;  
				}          
			}                             
			if (stim[item][p][5])  {
				nextItem();
			} 
			else {
				drawStim(false); // only repaint this item => erase X for this unselected choice
			}					
		}         
	}       
}


// end of task (research)
function theEnd()  
{     
  is_task= false;     
  document.getElementById("canvas").style.display="none"; // this disable doAnswer() event
  document.getElementById("footer").style.display="none";
  document.getElementById("end").style.display="block";  
  var res=0, err=0, mis=0, tot=itemCnt, is_sel;  // res= correct answers; err= errors, mis= missing values; tot= maximum possible score
  var freq=[];         //  category (0..2) x (correct, errors, missing) 
  var stime= neutral ? [0,0,0] : [0,0];        // sum of time group by stimulus category
  var j= neutral ? 2: 1;
  for (var i=0; i<=j; i++)  {
     freq[i]= [0,0,0];   // rows = category  type (0..2 or 0..1).  columns = correct(0), errors(1), missing(2)
  }  
	for (var i in stim)   
  {  // i == item    
		// times 
    if (itype[i] == 0)  {
      stime[0]+= itime[i];
    }
    else if (itype[i] == 1)  {
      stime[1]+= itime[i];
    }
    else  {
      stime[2]+= itime[i];
    }  
    is_sel= false;		
    // correct, incorrect, missing..
    for (var s in stim[i])   
    {  // s== shape
      if (stim[i][s][5])
      {
				is_sel= true;				
				if (stim[i][s][4]) 
				{ 
					res++;   // target and selected  => correct choices			       
					if (itype[i] == 0)  {
						freq[0][0]++;      //  consistent stimulus => correct choices  (second index=0)
					} 
					else if (itype[i] == 1)  {
						freq[1][0]++;       // inconsistent stimulus => correct choices
					} 
					else  {
						 freq[2][0]++;      // neutral stimulus  => correct choices
					}          
				}      
				else   
				{
					err++;     // non-target and selected => errors                
					if (itype[i] == 0)  {
						freq[0][1]++;      //  consistent stimulus => errors (second index=1)
					} 
					else if (itype[i] == 1)  {
						freq[1][1]++;       // inconsistent stimulus => errors
					} 
					else  {
						freq[2][1]++;         // neutral stimulus  => errors
					}          
				}
			}
    }  // for (var s in stim[i]) 		
		if (!is_sel)
		{
				mis++;       // target and not selected    => missing values                    
        if (itype[i] == 0)  {
          freq[0][2]++;      //  consistent stimulus  => missing values (second index=2)
        } 
        else if (itype[i] == 1)  {
          freq[1][2]++;       // inconsistent stimulus  => missing values
        } 
        else  {
          freq[2][2]++;      // neutral stimulus  => missing values
        }          	
			
		}	
  }   //  for (var i in stim)  i == item
	
  document.getElementById("score").textContent= "Correct= " + res + " Missing= " + mis + " Errors= " + err + " Maximum possible score= " + tot;
  document.getElementById("no_google").textContent="";  
  //document.getElementById("chart_title").style.display="none"; 

  try  {
    drawReport(res, err, mis, freq, stime);  
  }
  catch (e)  {
    document.getElementById("no_google").textContent= "You must have an available internet connection to display graphs and tables. Make sure you are online."; 
  }
  
  try 
  {
    if (store) {
      drawStorage(res,err,mis,tot);  
    }
  }        
  catch (e)  { 
    document.getElementById("table_grp").innerHTML= "Your browser probably doesn't have support for the Web Storage Object or access to the Storage Object is disabled. Check your browser settings. In some browsers (IE11, Edge) Storage Object is not enabled when accessed in a local file (offline)."; 
  }
           
}


/* async draw and display tables and charts with user results (call google API)..
  (chart = PIE + table) => Displays the sum of: correct answers, errors, and missing values  
  res = total correct answers in task (sum)
  err = total errors in task (sum)
  mis = total missing values in task (sum) 
  freq =  frequencies results:  category (0..1 or 0..2) x (correct, errors, missing). rows = category type (0..2 or 0..1).  columns = correct(0), errors(1), missing(2)  
  stime = sum of display times (ms) by item category  => [0] = consistent stimulus; [1]= inconsistent stimulus; [2] neutral stimulus  */
function drawReport(res, err, mis, freq, stime) 
{          
  document.getElementById("google_wrapper").style.display="block";  
  //    xxx  table = Displays the sum of: correct answers, errors, and missing values  xxx 
  var data = new google.visualization.DataTable(), s;    // Create and populate the data table. 
  data.addColumn('string', 'Answer type');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Sum');      // sum(correct answers, errors, missing values) = number = frequencies             
  data.addRow ( ["Correct", res] );
  data.addRow ( ["Errors", err] ); 
  data.addRow ( ["Missing", mis] );                                      
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };           
  var elem= document.getElementById("table");
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
  //    xxxxxx      PIE chart  => data are same   => draw PIE chart and table for correct, errors, missing values   xxxxxx 
  options= {   
   is3D: true, 
   legend: 'none',
   pieSliceText: 'value',
   tooltip: {text:'value'},    
   width: '100%',
   chartArea: {width:'100%'}
  };          //title: 'Correct answers, errors and missing values',   
  elem = document.getElementById("chart");   
  elem.style.display = "block"; 
  new google.visualization.PieChart(elem).draw(data, options);     // Create and draw the visualization.     
  //document.getElementById("chart_title").style.display="block";  
    
//  draw table and chart for correct answer group by stimulus category (0..1 or 0..2)   
//    xxxxxxxxxxxxxx          Chart2 group by stimulus category    xxxxxxxxxxxxxxxxx      

  data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Stimulus category');     // 1. col = must be string  
  data.addColumn('number', 'Correct'); 
  data.addColumn('number', 'Errors');      
  data.addColumn('number', 'Missing');      
 // rows = category  type (0..2 or 0..1).  columns = correct(0), errors(1), missing(2)  
	for (var i in freq)  
  {                              
      if (i == 0)  {
        s= 'Consistent stimuli';
      }                                    
      else if (i == 1)  {
        s= 'Inconsistent stimuli';
      } 
      else  {
        s= 'Neutral stimuli';
      }    
      data.addRow([ s,  freq[i][0], freq[i][1], freq[i][2] ]);     //  data.addRow([ s,  freq[i][0], freq[i][1],  {v: 0.1, f: '0'} ]);   
  }                 
  options= {
    title: 'Results are grouped by the Stimulus category. Total score = ' + res,
    width: '100%',  
    hAxis: {
      title: 'Stimulus category',
    }, 
    vAxis: {
      title: 'Scores'
    }   
  };    
  document.getElementById("chart2").style.display = "block";   
  new google.visualization.ColumnChart(document.getElementById('chart2')).draw(data, options);     // Create and draw the visualization.                       
        
   //    xxxxxxxxxxxxxx          Frequencies table2 group by stimulus category (data are same)   xxxxxxxxxxxxxxxxx                             
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };    // data are same         
  elem= document.getElementById("table2");
  elem.title="Total score=" + res;
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
		
	//  draw table and chart for item time group by stimulus category (0..1 or 0..2)   
  //    xxxxxxxxxxxxxx          chart3 item time by stimulus category    xxxxxxxxxxxxxxxxx      

  data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Stimulus category');     // 1. col = must be string  
  data.addColumn('number', 'Sum of time (ms). See Note');      
  for (var i in stime)	{                                   
		if (i == 0)  {
			s= 'Consistent stimuli';
		}                                    
		else if (i == 1)  {
			s= 'Inconsistent stimuli';
		} 
		else  {
			s= 'Neutral stimuli';
		}    
		data.addRow([ s, stime[i] ]);     //  if (stime[i]== 0) data.addRow([ s,  {v: 0.1, f: '0'} ]);   
  }                 
  options= {
    title: 'Total sum of time (on-screen display time) is grouped by stimulus categories. See Note',
    width: '100%',  
    hAxis: {
      title: 'Stimulus category',
    }, 
    vAxis: {
      title: 'Sum of time (ms)'
    }   
  };    
  document.getElementById("chart3").style.display = "block";   
  new google.visualization.ColumnChart(document.getElementById('chart3')).draw(data, options);     // Create and draw the visualization.                       
        
   //    xxxxxxxxxxxxxx          Frequencies table3 item time by stimulus category (data are same)   xxxxxxxxxxxxxxxxx                             
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };    // data are same         
  elem= document.getElementById("table3");
  elem.title="Total score=" + res;
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options); 
	
}


/*  use window.localStorage in client browser
    res = total correct answers in task (sum)
    err = total errors in task (sum)
    mis = total missing values in task (sum)
    tot = maximum possible score in task  */
function drawStorage(res,err,mis,tot)   
{  
  document.getElementById("table_grp").style.display="block";
  var oldItems = JSON.parse(localStorage.getItem("rst-v1.0-data")) || []; 
  var id= oldItems.length+1;     
  	
  // set new "record"
  var newItem = {
    'id': id,
    'date': new Date(),      
    'correct': res, 
    'errors': err,       
    'missing': mis,   
    'max-score': tot,
    'show-correct' : (demo) ? "Yes": "No",      
    'timer': timer,
    'items': itemCnt,
    'paradigm': (parad === "0") ? "Colors": "Spatial",		
    'match-type' : (mtype === "0") ? "Text content": "Font color",
    'choices-positions': ptype ? "Fixed" : "Random",
		'neutral': neutral ? "Yes" : "No",		
    'no-correct': no_correct ? "Yes" : "No",
		'is-back' : is_back ? "Yes" : "No",
		'is-forward' : is_forward ? "Yes": "No" 		
  };
  
  oldItems.push(newItem);

  localStorage.setItem("rst-v1.0-data", JSON.stringify(oldItems));

  createTableJSON(document.getElementById("table_grp"), oldItems); 
   
  document.getElementById("score").textContent+= ". (ID=" + id + ")";
 
}


// convert JSON data dynamically to HTML Table using JavaScript - Dynamically Create table with rows in JavaScript
// downloaded and adapted from source: https://www.encodedna.com/javascript/populate-json-data-to-html-table-using-javascript.htm
function createTableJSON(elem, my_json) 
{  
  // EXTRACT VALUE FOR HTML HEADER. 
  var col = [];
  for (var i = 0; i < my_json.length; i++) {
    for (var key in my_json[i]) {
        if (col.indexOf(key) === -1) {
            col.push(key);
        }
    }
  } 
  var table = document.createElement("table");
  table.setAttribute("class", "my_table");    // table.className = 'my_table';
  // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.
  var tr = table.insertRow(-1);                   // TABLE ROW.
  for (var i = 0; i < col.length; i++) {
      var th = document.createElement("th");      // TABLE HEADER.
      th.innerHTML = col[i];
      tr.appendChild(th);
  }
  // ADD JSON DATA TO THE TABLE AS ROWS.
  for (var i = 0; i < my_json.length; i++) 
  {
    tr = table.insertRow(-1);
    for (var j = 0; j < col.length; j++) {
      var tabCell = tr.insertCell(-1);
      tabCell.innerHTML = my_json[i][col[j]];
    }
  }
  // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
  elem.innerHTML= "";
  elem.appendChild(table);
}


// clear rst web browser storage data
function clrStorage()  
{  
  var cnt= localStorage.getItem("rst-v1.0-data")  ?  JSON.parse(localStorage.getItem("rst-v1.0-data")).length : 0;                                                        
  if (cnt === 0)  {
    alert("You have no rst data to delete");
    return;
  }  
  if ( !window.confirm("You have a total of " + cnt  + " rst results stored in your web browser. Continue?") ) { 
   return;
 }                                             
 if (window.confirm("Delete total saved rst results:  "  + cnt + ". This action cannot be undone. Final confirmation?") ) 
 { 
   window.localStorage.removeItem("rst-v1.0-data"); 
   document.getElementById("store_cnt").textContent= "All data has been deleted. No data";
 }  
}
